<!DOCTYPE html>
<html>
   <head>
      <meta http-equiv="pragma"        content="no-cache">
      <meta http-equiv="content-type"  content="text/html; charset=utf-8">
      <title>%value $host% - Analyze Package Dependencies</title>
      %invoke wia.pub.pkgdepend.ui.util:getStyleMetadata%
      <link rel="stylesheet" type="text/css" href="%value WmRoot/cssFilename%">
      <link rel="stylesheet" type="text/css" href="/WiaRoot/css/wrightia.css">
<!--[if lt IE 9]>
      <link rel="stylesheet" type="text/css" href="/WiaRoot/css/wrightia.lt_IE9.css">
<![endif]-->
      <link rel="stylesheet" type="text/css" href="css/package.css">
      <script type="text/javascript" src="/WiaRoot/scripts/wia4dsp.js"></script>
      <script type="text/javascript" src="/WiaRoot/scripts/wia4dom.js"></script>
      %end invoke%
      <style>
         tr#topLevelPackagesComment td {
            padding-right: 5px;
         }
         tr#topLevelPackagesComment div {
            width: 35em;
            padding: 2px 1em;
            background-color: #ffffed;
            border: 1px solid #e0e0c0;
            text-align: left;
         }
         /* compensation for leaving quirks-mode */
            td, body { font-size: 89%; }
            ul li a { font-size: 85%; }
            table.pageHeading tr td { font-size: 78%; }
            table.pageHeading tr td ul li a { font-size: 100%; }
         /* end */
      </style>
<!--[if lt IE 9]>
      <style>
         tr#topLevelPackagesComment div {
            padding-top: 1em;
            padding-bottom: 1em;
            width: 42em;
         }
      </style>
      <script type="text/javascript">
         String.prototype.trim = function() { return this.replace(/^\s+|\s+$/g, ""); };
      </script>
<![endif]-->
      <script type="text/javascript">

         function getPackageSelectors() {
            return getElementsByName("input", "packages");
            }

         function getSelectorRow(input) {
            return getParentElement(getParentElement(input, "td"), "tr");   // the parent table row;
            }

         function setAll(input) {
            var xIsChecked = input.checked;
            var xSelectors = getPackageSelectors();

            if (xSelectors)
               for(var xIdx = 0; xIdx < xSelectors.length; xIdx++)
                  {
                  var xRow = getSelectorRow(xSelectors[xIdx]);    // the parent table row

                  if (xRow.style.display != "none")
                     {
                     xSelectors[xIdx].checked = xIsChecked;
                     activeStatus(xSelectors[xIdx]);
                     }
                  }
            }

         function showAllSelectedPackages() {
            var xSelectors = getPackageSelectors();

            if (xSelectors)
               {
               document.getElementById("filter").value = "";      // reset
               var xAllChecked = document.getElementById("checkAll");

               xAllChecked.checked = true;                        // assumed

               for(var xIdx = 0; xIdx < xSelectors.length; xIdx++)
                  {
                  var xRow        = getSelectorRow(xSelectors[xIdx]);   // the parent table row
                  var xIsShowable = xSelectors[xIdx].checked;

                  if (!xIsShowable)
                     {
                     var xTargetId  = "void_" + xSelectors[xIdx].value;
                     var xTargetObj = document.getElementById(xTargetId);

                     xIsShowable = xTargetObj.checked;
                     }

                  if (xIsShowable)
                     {
                     xRow.style.display = "";
                     if (!xSelectors[xIdx].checked)
                        xAllChecked.checked = false;              // assumption failed
                     }
                  else
                     xRow.style.display = "none";                 // hide
                  }
               }
            }

         function showAllPackages() {
            var xSelectors = getPackageSelectors();

            if (xSelectors)
               {
               document.getElementById("filter").value = "";      // reset
               var xAllChecked = document.getElementById("checkAll");

               xAllChecked.checked = true;                        // assumed

               for(var xIdx = 0; xIdx < xSelectors.length; xIdx++)
                  {
                  var xRow = getSelectorRow(xSelectors[xIdx]);    // the parent table row

                  xRow.style.display = "";                        // show
                  if (!xSelectors[xIdx].checked)
                     xAllChecked.checked = false;                 // assumption failed
                  }
               }
            }

         function refreshPackageList() {
            var xResult                = true;
            var xSelectors             = getPackageSelectors();

            if (!xSelectors)
               return false;              // nothing to do

            var xFilterRE              = document.getElementById("filter").value.trim();
            var xAllChecked            = document.getElementById("checkAll");

            xAllChecked.checked = true;   // assumed

            // compile RE pattern matcher
            var xIsPatternDefined      = (xFilterRE && xFilterRE != "");
            var xPatternMatcher        = null;

            try{
               if (xIsPatternDefined)
                  xPatternMatcher      = new RegExp(xFilterRE);
               else
                  xPatternMatcher      = new RegExp("^.*$");
               }
            catch(xErr)
               {
               alert("Bad regular expression.");
               xResult = false;
               }

            if (xResult)
               {
               // apply filters
               for(var xIdx = 0; xIdx < xSelectors.length; xIdx++)
                  {
                  var xThis         = xSelectors[xIdx];
                  var xRow          = getSelectorRow(xThis);   // the parent table row
                  var xIsShowable   = xPatternMatcher.test(xThis.value);

                  if (!xIsShowable)
                     xRow.style.display = "none";
                  else
                     {
                     xRow.style.display = "";
                     if (!xSelectors[xIdx].checked)
                        xAllChecked.checked = false;  // assumption failed
                     }
                  }
               }

            return xResult;
            }

         function generateDependenciesReport() {
            setFormAction("ReportDependencies.dsp");
            document.getElementById("execute").value     = "report";
            document.getElementById("alpha_overlay").style.display = "block";
            return true;
            }


         function downloadDependenciesReportAsText() {
            setFormAction("ReportDependenciesAsText.dsp");
            document.getElementById("execute").value     = "report";
            return true;
            }

         function setFormAction(address) {
            try{
               document.frmPackageList.action=address;
               }
            catch(e)
               {
               // IE8 & IE9 do not accept writting to the form's action directly
               var xForm = document.getElementById("frmPackageList");

               if (xForm)
                  xForm.setAttribute("action", address);
               }
         }

         function setReportTopLevelOnly(input) {
            var xIsChecked    = input.checked;
            var xPackageList  = document.getElementById("listOfPackages");
            var xInputRE      = document.getElementById("inputRE");
            var xISSPROF      = document.getElementById("issprof");
            var xComment      = document.getElementById("topLevelPackagesComment");
            var xSelectors    = getPackageSelectors();

            if (xPackageList && xInputRE)
               if (xIsChecked)
                  {
                  if (xSelectors)
                     for(var xIdx = 0; xIdx < xSelectors.length; xIdx++)
                        xSelectors[xIdx].checked = !xIsChecked;
                  xPackageList.style.display = "none";
                  xInputRE.style.display     = "none";
                  xISSPROF.style.display     = "none";
                  xComment.style.display     = "";
                  }
               else
                  {
                  xPackageList.style.display = "";
                  xInputRE.style.display     = "";
                  xISSPROF.style.display     = "";
                  xComment.style.display     = "none";
                  }

            return true;
         }

         function activeStatus(input) {
            if (input)
               {
               if      (input.id.substring(0, 5) == "selc_")   // act upon the 'voided' checkbox
                  {
                  var xTargetId  = "void_" + input.value;
                  var xTargetObj = document.getElementById(xTargetId);

                  if (xTargetObj)
                     {
                     if (input.checked)
                        {
                        xTargetObj.checked  = false;
                        xTargetObj.disabled = true;
                        }
                     else
                        xTargetObj.disabled = false;
                     }
                  }
               }
            }

      %invoke wia.pub.pkgdepend.ui.analysis:analysisReport%

         function isPreviouslySelectedPackage(name) {
            var xResult = false;

            %ifvar packages%
               var xPackages = [%loop packages%"%value%"%loopsep ','%%end loop%];

               for(var xIdx = 0; xIdx < xPackages.length; xIdx++)
                  {
                  if (xPackages[xIdx] === name)
                     {
                     xResult = true;
                     break;
                     }
                  }
            %end if%

            return xResult;
         }

         function isPreviouslyVoidedPackage(name) {
            var xResult = false;

            %ifvar voidedPackages%
               var xPackages = [%loop voidedPackages%"%value%"%loopsep ','%%end loop%];

               for(var xIdx = 0; xIdx < xPackages.length; xIdx++)
                  {
                  if (xPackages[xIdx] === name)
                     {
                     xResult = true;
                     break;
                     }
                  }
            %end if%

            return xResult;
         }

      %end invoke%
      %rename packages psp%
      %rename voidedPackages pvp%
      %rename filter previousFilter%
      %rename isConsiderRuntimeData wasConsiderRuntimeData%

      function setPackageChecked(name) {
         if (name && isPreviouslyVoidedPackage && isPreviouslySelectedPackage)
            {
            var xSelectable = document.getElementById("selc_" + name);

            if (xSelectable)
               {
               xSelectable.checked = isPreviouslySelectedPackage(name);
               document.getElementById("void_" + name).checked = isPreviouslyVoidedPackage(name);
               activeStatus(xSelectable);
               }
            }
      }
      </script>
   </head>

   <body>
      <div id="alpha_overlay" style="display:none;">
         <div class="processingMessage">Analyzing...</div>
      </div>

      <table class="pageHeading">
         <tr>
            %invoke wia.pub.pkgdepend.ui.about:getMetadata%
               <td class="menusection-DependencyAnalysis" colspan="2">%value packageLongName%, %value packageVersion% &gt; Analyzer</td>
            %end invoke%
         </tr>
         <tr>
            <td>
               <ul>
                  <li><a href="./">Go Home</a></li>
               </ul>
            <td>
         </tr>
      </table>

      <table width="100%"> <!-- this table is being used only to set a left identation to the child tables -->
         <tr>
            <td width="10">&nbsp;</td>
            %invoke wia.pub.pkgdepend.ui.analysis.util:listPackages%
               %ifvar packages%
                  <td>
                     <a name="options"></a>
                     <ul class="options">
                        <li><a href="#actions" >Go Bottom</a></li>
                        <li> | </li>
                        <li><a href="javascript:void" onclick="javascript: showAllSelectedPackages();">Show all selected packages</a></li>
                        <li> | </li>
                        <li><a href="javascript:void" onclick="javascript: showAllPackages();">Show all packages</a></li>
                     </ul>
                     <form id="frmPackageList" name="frmPackageList" method="post" action="ReportDependencies.dsp">
                        <table name="packageList">
                           <thead>
                              <tr class="heading">
                                 <td colspan="3">List of enabled packages</td>
                              </tr>
                              <tr>
                                 <td class="evenrow" colspan="3">
                                    <table width="100%">
                                       %ifvar remoteServer%
                                          <tr>
                                             <td class="evenrowdata-r">
                                                Run on server:
                                             </td>
                                             <td class="evenrowdata-l">
                                                <input type="hidden" name="remoteServer" value="%value remoteServer%" />
                                                %value remoteServer%
                                             </td>
                                             <td>&nbsp;</td>
                                          </tr>
                                       %endif%
                                       <tr id="inputRE">
                                          <td class="evenrowdata-r">
                                             Regular Expression:
                                          </td>
                                          <td class="evenrowdata-l">
                                             <input type="text" id="filter" name="filter" value="%value previousFilter%" style="width: 100%;" />
                                          </td>
                                          <td class="evenrowdata-l">
                                             <a href="#" onclick="javascript: refreshPackageList();" title="Refresh package list">
                                                <img src="images/cmd_seedetail.gif" alt="Refresh package list" border="0" />
                                             </a>
                                          </td>
                                       </tr>
                                       <tr id="issprof">
                                          <td class="evenrowdata-r">
                                             Use runtime references:
                                          </td>
                                          <td class="evenrow-l" colspan="2">
                                             <input type="checkbox" name="isConsiderRuntimeData"
                                                %ifvar wasConsiderRuntimeData%
                                                   %ifvar wasConsiderRuntimeData equals('true')%
                                                      checked
                                                   %endif%
                                                %else%
                                                   %ifvar isConsiderRuntimeData%
                                                      %ifvar isConsiderRuntimeData equals('true')%
                                                         checked
                                                      %endif%
                                                   %else%
                                                      checked
                                                   %endif%
                                                %endif%
                                             />
                                             (<em>tries to use Service Profiler data</em>)
                                          </td>
                                       </tr>
                                       <tr>
                                          <td class="evenrowdata-r">
                                             Only unreferenced packages:
                                          </td>
                                          <td class="evenrow-l" colspan="2">
                                             <input type="checkbox" name="isTopLevelPackagesOnly" id="isTopLevelPackagesOnly" onclick="javascript: setReportTopLevelOnly(this);" %ifvar isTopLevelPackagesOnly equals('true')%checked%endif%/>
                                             (<em>reports only top level packages</em>)
                                          </td>
                                       </tr>
                                       <tr id="topLevelPackagesComment">
                                          <td colspan="3">
                                             <div>
                                                <p>
                                                   This operation may take a while.
                                                </p>
                                                <p>
                                                   Because all enabled packages will be considered,
                                                   your package selection is being discarded.
                                                </p>
                                             </div>
                                          </td>
                                       </tr>
                                    </table>
                                 </td>
                              </tr>
                           </thead>
                           <tbody id="listOfPackages">
                              <tr>
                                 <td class="columnHeading">Package Name</td>
                                 <td class="columnHeading-c">
                                    <input type="checkbox" id="checkAll" name="checkAll" onclick="javascript: setAll(this);" />
                                 </td>
                                 <td class="columnHeading-c">Voided</td>
                              </tr>
                              %loop packages%
                                 <tr class="selectableRow">
                                    <td class="evenrow-l">%value packages%</td>
                                    <td class="evenrowdata"><input type='checkbox' id='selc_%value%' name='packages'       value='%value%' onclick='javascript: activeStatus(this)' /></td>
                                    <td class="evenrowdata"><input type='checkbox' id='void_%value%' name='voidedPackages' value='%value%' /></td>
                                    <script type="text/javascript">
                                       setPackageChecked("%value%");
                                    </script>
                                 </tr>
                              %end loop%
                           <tbody>
                           <tfoot>
                              <tr>
                                 <td class="action" colspan="3">
                                    <a name="actions"></a>
                                    <input type="submit" name="cmdReport"        id="cmdReport"       value="Generate Analysis Report"          onclick="return generateDependenciesReport();" />
                                    <input type="submit" name="cmdReportAsText"  id="cmdReportAsText" value="Download Analysis Report as Text"  onclick="return downloadDependenciesReportAsText();" />
                                    <input type="hidden" name="execute"          id="execute"/>
                                 </td>
                              </tr>
                           </tfoot>
                        </table>
                     </form>
                     <ul class="options">
                        <li><a href="#options" >Go Top</a></li>
                     </ul>
                  </td>
               %else%
                  <td class="message">
                     No enabled packages.
                  </td>
               %end if%
            %onerror%
               <tr>
                  <td class="message" colspan="2">
                     %value errorMessage%
                  </td>
               </tr>
            %end invoke%
         </tr>
      </table>
      <script type="text/javascript">
         document.getElementById("topLevelPackagesComment").style.display = "none";
         setReportTopLevelOnly(document.getElementById("isTopLevelPackagesOnly"));
         refreshPackageList();
      </script>
   </body>
</html>
